// This file was generated by Dashcode from Apple Computer, Inc.
// You may edit this file to customize your Dashboard widget.

// Properties set by attributes panel
var updateInterval;

// Monitor objects
var ioMonitor;
var netMonitor;
var monitorsRunning;

function load()
{
	setupParts();

	// Get the properties
	updateInterval = +attributes.updateInterval;
	if (!updateInterval) {
		updateInterval = 1;
	}
	
	initMonitors();
}

// Set the contents of an HTML div
function setElementText(elementName, elementValue)
{
	var element = document.getElementById(elementName);
	if (element) {
		element.innerText = elementValue;
	}
}

// Keep a running max-seen value to scale the gauge to
function makeMaxTracker (callback, min, valuesToTrack)
{
	if (valuesToTrack == null) {
		valuesToTrack = 60;
	}

	if (min == null) {
		min = 1.0;
	}

	var trackValues = new Array();

	var tracker = function (value)
	{
		trackValues.push(value);
		if (trackValues.length > valuesToTrack) {
			trackValues.shift();
		}
	
		var max = min;
		for (var i = 0; i < trackValues.length; i++) {
			if (trackValues[i] > max) {
				max = trackValues[i];
			}
		}
	
		callback(value, max);
	};

	return tracker;
}

function setGaugeValue (gaugeId, value)
{
	var element = document.getElementById(gaugeId);
	if (element != null && element.object != null && element.object.setValue != null) {
		element.object.setValue(value);
	}
}

function initMonitors()
{
	var trackIOValues = makeMaxTracker(
		function (value, max)
		{
			setGaugeValue("gauge2", 100 * value / max);
		});

	ioMonitor = new IOStatMonitor(updateInterval);
	ioMonitor.loadCallback = function (value) { setGaugeValue("gauge1", value); };
	ioMonitor.ioCallback = trackIOValues;
	ioMonitor.start();

	var trackNetIn = makeMaxTracker(
		function (value, max)
		{
			var percent = 100 * value / max;
			if (value < 100) {
				percent = null;
			}
			setGaugeValue("gauge3", percent);
		}, 2000, 10);

	var trackNetOut = makeMaxTracker(
		function (value, max)
		{
			var percent = 100 * value / max;
			if (value < 100) {
				percent = null;
			}
			setGaugeValue("gauge4", percent);
		}, 2000, 10);

	netMonitor = new NetStatMonitor(updateInterval);
	netMonitor.ioCallback = function (net_in, net_out) { trackNetIn(net_in); trackNetOut(net_out); };
	netMonitor.start();
	
	monitorsRunning = true;
}

function remove()
{
	// your widget has just been removed from the layer
	// remove any preferences as needed
    // widget.setPreferenceForKey(null, createInstancePreferenceKey("your-key"));
}

function hide()
{
	// your widget has just been hidden stop any timers to
	// prevent cpu usage
	if (monitorsRunning) {
		ioMonitor.stop();
		netMonitor.stop();
		monitorsRunning = false;
	}
}

function show()
{
	// your widget has just been shown.  restart any timers
	// and adjust your interface as needed
	if (monitorsRunning === false) {
		ioMonitor.start();
		netMonitor.start();
		monitorsRunning = true;
	}
}

function showBack(event)
{
	// your widget needs to show the back

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToBack");

	front.style.display="none";
	back.style.display="block";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}

function showFront(event)
{
	// your widget needs to show the front

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToFront");

	front.style.display="block";
	back.style.display="none";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}

if (window.widget)
{
	widget.onremove = remove;
	widget.onhide = hide;
	widget.onshow = show;
}
